git-rebase.sh 8.2 KB
Newer Older
1 2 3 4 5
#!/bin/sh
#
# Copyright (c) 2005 Junio C Hamano.
#

6
USAGE='[-v] [--onto <newbase>] <upstream> [<branch>]'
7 8 9 10 11
LONG_USAGE='git-rebase replaces <branch> with a new branch of the
same name.  When the --onto option is provided the new branch starts
out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
It then attempts to create a new commit for each commit from the original
<branch> that does not exist in the <upstream> branch.
12

13 14
It is possible that a merge failure will prevent this process from being
completely automatic.  You will have to resolve any such merge failure
15 16 17 18
and run git rebase --continue.  Another option is to bypass the commit
that caused the merge failure with git rebase --skip.  To restore the
original <branch> and remove the .dotest working files, use the command
git rebase --abort instead.
19

20 21 22
Note that if <branch> is not specified on the command line, the
currently checked out branch is used.  You must be in the top
directory of your project to start (or continue) a rebase.
23

24
Example:       git-rebase master~1 topic
25

26 27 28
        A---B---C topic                   A'\''--B'\''--C'\'' topic
       /                   -->           /
  D---E---F---G master          D---E---F---G master
29
'
30 31

SUBDIRECTORY_OK=Yes
32
. git-sh-setup
33
set_reflog_action rebase
34
require_work_tree
35
cd_to_toplevel
36

37 38 39 40 41
RESOLVEMSG="
When you have resolved this problem run \"git rebase --continue\".
If you would prefer to skip this patch, instead run \"git rebase --skip\".
To restore the original branch and stop rebasing run \"git rebase --abort\".
"
42
unset newbase
J
Junio C Hamano 已提交
43
strategy=recursive
44 45 46
do_merge=
dotest=$GIT_DIR/.dotest-merge
prec=4
47
verbose=
48 49 50 51 52 53 54 55 56 57

continue_merge () {
	test -n "$prev_head" || die "prev_head must be defined"
	test -d "$dotest" || die "$dotest directory does not exist"

	unmerged=$(git-ls-files -u)
	if test -n "$unmerged"
	then
		echo "You still have unmerged paths in your index"
		echo "did you forget update-index?"
58
		die "$RESOLVEMSG"
59 60 61 62
	fi

	if test -n "`git-diff-index HEAD`"
	then
63 64 65 66 67 68
		if ! git-commit -C "`cat $dotest/current`"
		then
			echo "Commit failed, please do not call \"git commit\""
			echo "directly, but instead do one of the following: "
			die "$RESOLVEMSG"
		fi
69
		printf "Committed: %0${prec}d" $msgnum
70
	else
71
		printf "Already applied: %0${prec}d" $msgnum
72
	fi
73 74
	echo ' '`git-rev-list --pretty=oneline -1 HEAD | \
				sed 's/^[a-f0-9]\+ //'`
75 76 77 78 79 80 81

	prev_head=`git-rev-parse HEAD^0`
	# save the resulting commit so we can read-tree on it later
	echo "$prev_head" > "$dotest/prev_head"

	# onto the next patch:
	msgnum=$(($msgnum + 1))
82
	echo "$msgnum" >"$dotest/msgnum"
83 84 85
}

call_merge () {
86
	cmt="$(cat $dotest/cmt.$1)"
87
	echo "$cmt" > "$dotest/current"
88 89 90 91 92 93 94 95
	hd=$(git-rev-parse --verify HEAD)
	cmt_name=$(git-symbolic-ref HEAD)
	msgnum=$(cat $dotest/msgnum)
	end=$(cat $dotest/end)
	eval GITHEAD_$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
	eval GITHEAD_$hd='"$(cat $dotest/onto_name)"'
	export GITHEAD_$cmt GITHEAD_$hd
	git-merge-$strategy "$cmt^" -- "$hd" "$cmt"
96 97 98
	rv=$?
	case "$rv" in
	0)
99
		unset GITHEAD_$cmt GITHEAD_$hd
100
		return
101 102 103
		;;
	1)
		test -d "$GIT_DIR/rr-cache" && git-rerere
104
		die "$RESOLVEMSG"
105 106 107
		;;
	2)
		echo "Strategy: $rv $strategy failed, try another" 1>&2
108
		die "$RESOLVEMSG"
109 110 111 112 113 114 115 116 117 118 119 120 121
		;;
	*)
		die "Unknown exit code ($rv) from command:" \
			"git-merge-$strategy $cmt^ -- HEAD $cmt"
		;;
	esac
}

finish_rb_merge () {
	rm -r "$dotest"
	echo "All done."
}

122 123 124
while case "$#" in 0) break ;; esac
do
	case "$1" in
125 126 127 128 129 130 131 132
	--continue)
		diff=$(git-diff-files)
		case "$diff" in
		?*)	echo "You must edit all merge conflicts and then"
			echo "mark them as resolved using git update-index"
			exit 1
			;;
		esac
133 134 135 136 137 138 139 140 141 142 143 144 145 146 147
		if test -d "$dotest"
		then
			prev_head="`cat $dotest/prev_head`"
			end="`cat $dotest/end`"
			msgnum="`cat $dotest/msgnum`"
			onto="`cat $dotest/onto`"
			continue_merge
			while test "$msgnum" -le "$end"
			do
				call_merge "$msgnum"
				continue_merge
			done
			finish_rb_merge
			exit
		fi
148
		git am --resolved --3way --resolvemsg="$RESOLVEMSG"
149 150 151
		exit
		;;
	--skip)
152 153
		if test -d "$dotest"
		then
154 155 156 157
			if test -d "$GIT_DIR/rr-cache"
			then
				git-rerere clear
			fi
158 159 160 161 162 163 164 165 166 167 168 169
			prev_head="`cat $dotest/prev_head`"
			end="`cat $dotest/end`"
			msgnum="`cat $dotest/msgnum`"
			msgnum=$(($msgnum + 1))
			onto="`cat $dotest/onto`"
			while test "$msgnum" -le "$end"
			do
				call_merge "$msgnum"
				continue_merge
			done
			finish_rb_merge
			exit
170
		fi
171
		git am -3 --skip --resolvemsg="$RESOLVEMSG"
172 173 174
		exit
		;;
	--abort)
175 176 177 178
		if test -d "$GIT_DIR/rr-cache"
		then
			git-rerere clear
		fi
179 180 181 182 183 184 185 186 187
		if test -d "$dotest"
		then
			rm -r "$dotest"
		elif test -d .dotest
		then
			rm -r .dotest
		else
			die "No rebase in progress?"
		fi
188 189 190
		git reset --hard ORIG_HEAD
		exit
		;;
191 192 193 194 195
	--onto)
		test 2 -le "$#" || usage
		newbase="$2"
		shift
		;;
196 197 198 199 200 201 202 203
	-M|-m|--m|--me|--mer|--merg|--merge)
		do_merge=t
		;;
	-s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
		--strateg=*|--strategy=*|\
	-s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
		case "$#,$1" in
		*,*=*)
D
Dennis Stosberg 已提交
204
			strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
205 206 207 208 209 210 211 212
		1,*)
			usage ;;
		*)
			strategy="$2"
			shift ;;
		esac
		do_merge=t
		;;
213 214 215
	-v|--verbose)
		verbose=t
		;;
216 217 218 219 220 221 222 223 224
	-*)
		usage
		;;
	*)
		break
		;;
	esac
	shift
done
225

226
# Make sure we do not have .dotest
227
if test -z "$do_merge"
228
then
229 230 231 232 233
	if mkdir .dotest
	then
		rmdir .dotest
	else
		echo >&2 '
234 235 236 237
It seems that I cannot create a .dotest directory, and I wonder if you
are in the middle of patch application or another rebase.  If that is not
the case, please rm -fr .dotest and run me again.  I am stopping in case
you still have something valuable there.'
238 239 240 241 242 243 244 245
		exit 1
	fi
else
	if test -d "$dotest"
	then
		die "previous dotest directory $dotest still exists." \
			'try git-rebase < --continue | --abort >'
	fi
246 247
fi

248
# The tree must be really really clean.
J
Junio C Hamano 已提交
249
git-update-index --refresh || exit
250
diff=$(git-diff-index --cached --name-status -r HEAD)
L
Lukas Sandström 已提交
251
case "$diff" in
252 253 254 255
?*)	echo "$diff"
	exit 1
	;;
esac
J
Junio C Hamano 已提交
256

257 258 259
# The upstream head must be given.  Make sure it is valid.
upstream_name="$1"
upstream=`git rev-parse --verify "${upstream_name}^0"` ||
J
Jason Riedy 已提交
260
    die "invalid upstream $upstream_name"
L
Lukas Sandström 已提交
261

262 263 264 265 266 267 268 269 270
# If a hook exists, give it a chance to interrupt
if test -x "$GIT_DIR/hooks/pre-rebase"
then
	"$GIT_DIR/hooks/pre-rebase" ${1+"$@"} || {
		echo >&2 "The pre-rebase hook refused to rebase."
		exit 1
	}
fi

271
# If the branch to rebase is given, first switch to it.
272
case "$#" in
273
2)
274
	branch_name="$2"
275
	git-checkout "$2" || usage
276 277 278
	;;
*)
	branch_name=`git symbolic-ref HEAD` || die "No current branch"
279
	branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
280
	;;
281
esac
282
branch=$(git-rev-parse --verify "${branch_name}^0") || exit
283

284 285 286
# Make sure the branch to rebase onto is valid.
onto_name=${newbase-"$upstream_name"}
onto=$(git-rev-parse --verify "${onto_name}^0") || exit
L
Lukas Sandström 已提交
287

288 289 290 291
# Now we are rebasing commits $upstream..$branch on top of $onto

# Check if we are already based on $onto, but this should be
# done only when upstream and onto are the same.
292 293
mb=$(git-merge-base "$onto" "$branch")
if test "$upstream" = "$onto" && test "$mb" = "$onto"
294
then
295 296
	echo >&2 "Current branch $branch_name is up to date."
	exit 0
297 298
fi

299 300 301 302 303 304
if test -n "$verbose"
then
	echo "Changes from $mb to $onto:"
	git-diff-tree --stat --summary "$mb" "$onto"
fi

305
# Rewind the head to "$onto"; this saves our current head in ORIG_HEAD.
306
echo "First, rewinding head to replay your work on top of it..."
307
git-reset --hard "$onto"
L
Lukas Sandström 已提交
308

309
# If the $onto is a proper descendant of the tip of the branch, then
L
Lukas Sandström 已提交
310
# we just fast forwarded.
311
if test "$mb" = "$branch"
L
Lukas Sandström 已提交
312
then
313
	echo >&2 "Fast-forwarded $branch_name to $onto_name."
L
Lukas Sandström 已提交
314 315 316
	exit 0
fi

317 318
if test -z "$do_merge"
then
319
	git-format-patch -k --stdout --full-index --ignore-if-in-upstream "$upstream"..ORIG_HEAD |
320
	git am --binary -3 -k --resolvemsg="$RESOLVEMSG"
321 322 323 324 325 326 327 328
	exit $?
fi

# start doing a rebase with git-merge
# this is rename-aware if the recursive (default) strategy is used

mkdir -p "$dotest"
echo "$onto" > "$dotest/onto"
329
echo "$onto_name" > "$dotest/onto_name"
330 331 332 333 334
prev_head=`git-rev-parse HEAD^0`
echo "$prev_head" > "$dotest/prev_head"

msgnum=0
for cmt in `git-rev-list --no-merges "$upstream"..ORIG_HEAD \
M
Michal Rokos 已提交
335
			| @@PERL@@ -e 'print reverse <>'`
336 337
do
	msgnum=$(($msgnum + 1))
338
	echo "$cmt" > "$dotest/cmt.$msgnum"
339 340
done

341 342
echo 1 >"$dotest/msgnum"
echo $msgnum >"$dotest/end"
343 344 345 346 347 348 349 350 351

end=$msgnum
msgnum=1

while test "$msgnum" -le "$end"
do
	call_merge "$msgnum"
	continue_merge
done
352

353
finish_rb_merge